package de.donmanfred;

import com.amazon.device.messaging.ADM;
import com.amazon.device.messaging.development.ADMManifest;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.objects.ADMHelper;

@ShortName("ADM")
@Author("DonManfred")
@Version(0.03f)

@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"amazon-device-messaging-1.1.0.jar"})

public class ADMwrapper extends AbsObjectWrapper<ADMHelper> {
	private BA ba;
	private String eventName;
	private ADM adm;
	/**
	 *  <link>...|http://www.b4x.com</link>
	 */
	public static void LIBRARY_DOC() {
	}

	public void Initialize(BA ba, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		this.setObject(new ADMHelper());
		if (getObject().IS_ADM_AVAILABLE) {
			adm = new ADM(BA.applicationContext);	
		}
 	}
	public boolean getisClassAvailable() {
		return getObject().isClassAvailable(ADMHelper.ADM_CLASSNAME);
	}
	public boolean getIS_ADM_AVAILABLE() {
		return getObject().IS_ADM_AVAILABLE;
	}
	public boolean getIS_ADM_V2() {
		return getObject().IS_ADM_V2;
	}
	public String getRegistrationId() {
		if (getObject().IS_ADM_AVAILABLE) {
			return adm.getRegistrationId();
		}
		return "";
	}
	public void startRegister() {
		if (getObject().IS_ADM_AVAILABLE) {
			adm.startRegister();
		}
	}
	public void startUnRegister() {
		if (getObject().IS_ADM_AVAILABLE) {
			adm.startUnregister();
		}
	}
	public boolean getSupported() {
		if (getObject().IS_ADM_AVAILABLE) {
			return adm.isSupported();
		}
		return false;
	}
	public void checkManifestAuthoredProperly(BA ba) {
		if (getObject().IS_ADM_AVAILABLE) {
			ADMManifest.checkManifestAuthoredProperly(ba.applicationContext);
		}
	}


	
	
}
